#include <iostream>
#include "Database.h"
#include "UInterface.h"
#include "QueryPlanTree.h"
#include "evaluateFuction.h"
#include "QueryPlanNode.h"
#include "MyPCL.h"

//CC
#include "CC_Operators.h"
#include "CC_CSSTree.h"
//CO
#include "CC_Operators.h"
#include "CC_CSSTree.h"

#include "batchQuery.h"

#include "testPrimitive.h"
#include "DBArray.h"
#include "RowExec.h"
#include "UnitTest.h"
#include "DemoTest.h"


using namespace std;

Database *easedb;
MyPCL *pcl;
int alphaRatio=8;//8;//32
int BASESIZE=128;//8;
double s_excludeTime=0;



void usage()
{
	cout<<"Usage of some general tests in EaseDB"<<endl;
	cout<<"-EXEC <queyr> <mode>, for executing query from front end, |R|=4M, |S|=4M, r=s=8B"<<endl;
	cout<<"-ROW <op>, for row test, |R|=32K, |S|=32K, r=s=128B"<<endl;
	cout<<"-COLUMN <op>, for column test, |R|=4M, |S|=4M, r=s=8B"<<endl;
	cout<<"-THREAD <op> <numthread> <mode>, for query test, |R|=4M, |S|=4M, r=s=8B"<<endl;
	cout<<"\t <op>=0 for sort, <op>=1 for join"<<endl;
	cout<<"\t <mode>=0 for cache-conscious, <op>=1 for Cache-oblivious"<<endl;
}


int main(int argc, char ** argv)
{
	//this is for demonstration purpose. 
	//For completeness, there should be a java frontend to connect.
	int i=0;
	for(i=0;i<argc;i++)
	{
		if(strcmp(argv[i],"-ROW")==0)
		{
			if((i+1)!=argc)
				row_test(atoi(argv[i+1]));
			else
				row_test();
			return 0;
		}
		else if(strcmp(argv[i],"-COLUMN")==0)
		{
			if((i+1)!=argc)
				column_test(atoi(argv[i+1]));
			else
				column_test();
			return 0;
		}
		else if(strcmp(argv[i],"-THREAD")==0)
		{
			query_test(atoi(argv[i+1]), atoi(argv[i+2]), atoi(argv[i+3]));
			return 0;
		}
		else if(strcmp(argv[i], "-EXEC")==0)
		{
			exec_query(argv[i+1],atoi(argv[i+2]));
			return 0;
		}
	}
	usage();
	return 1;
}

