#include "CC_Operators.h"
#include "CO_Operators.h"
#include "Operators.h"
#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include "config.h"
#include "qpUtility.h"
#include "assert.h"
#include "LinkedList.h"
#include "CC_CSSTree.h"
#include "CC_HashTable.h"
#include "evaluateFuction.h"
#include "time.h"
#include <iostream>
using namespace std;



//#include "MyPCL.h"
//extern MyPCL *pcl;

/*
We return the result <R.rid, S.rid> for further construction the result.
*/

int cc_ninlj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout)
{
	__DEBUG__("cc_ninlj");
	int numResult = 0;
	int i=0;
	int j=0;
	int k=0;
	int m=0;
	int startIndex=0;
	int endIndex=0;
	//LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
	LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList));
	ll->init();
	int numBlock=rLen/NLJ_BLOCK_SIZE;
	if (rLen%NLJ_BLOCK_SIZE!=0) 
		numBlock=numBlock+1;
	Record r;
	int data[2];
	__DEBUG2__("initialPredicate", pRoot->CC_str);
	initialPredicate(pRoot->CC_str);
	void **dllHandle=(void**)malloc(sizeof(void*));
	IN_INT_OUT_INT PEVAL=openDLL(dllHandle);
	int stack[128];
	for(i=0;i<(numBlock-1);i++)
	{
		startIndex=i*NLJ_BLOCK_SIZE;
		endIndex=(i+1)*NLJ_BLOCK_SIZE;
		for(j=0;j<sLen;j++)
		{
			data[1]=S[j].value;
			for(k=startIndex;k<endIndex;k++)
			{
				//if (R[k].value==S[j].value) 
				data[0]=R[k].value;
#ifdef NON_LINUX_PLAT
				if(evaluate(data,pRoot, stack, MAX_PREDICATE_NODE))
#else
				if(PEVAL(data))
#endif
				{	
					r.rid=R[k].rid;
					r.value=S[j].rid;
					ll->fill(&r);
					numResult++;				
				}
			}
		}
	}
	//for the last block.
	startIndex=i*NLJ_BLOCK_SIZE;
	endIndex=rLen;
	for(j=0;j<sLen;j++)
	{
		data[1]=S[j].value;
		for(k=startIndex;k<endIndex;k++)
		{
			
			data[0]=R[k].value;			
#ifdef NON_LINUX_PLAT
				if(evaluate(data,pRoot,stack, MAX_PREDICATE_NODE))
#else
				if(PEVAL(data))
#endif
			{
				r.rid=R[k].rid;
				r.value=S[j].rid;
				ll->fill(&r);
				numResult++;
			}
		}
	}
	if(numResult!=0)
	{
		*Rout=(Record*)malloc(sizeof(Record)*numResult);
		ll->copyToArray(*Rout);
	}
	delete ll;
	closeDLL(dllHandle);
	return numResult;
}

int cc_multiNLJ(Record **input,int num_col, int rNumColumn, int rLen,int sLen, PREDICATE_NODE * pRoot, Record ** Rout)
{
	__DEBUG__("cc_multiNLJ");
	int numResult = 0;
	int i=0;
	int j=0;
	int k=0;
	int m=0;
	int startIndex=0;
	int endIndex=0;
	LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
	int nlj_blk_size=L2_CAP/(sizeof(Record)*num_col);
	int numBlock=rLen/nlj_blk_size;
	if (rLen%nlj_blk_size!=0) 
		numBlock=numBlock+1;
	Record r;
	int *data=(int*)malloc(sizeof(int)*num_col);
	int col=0;
	int lastColumn=num_col-1;
	int depth=num_col*3;
	int *localStack=(int*)malloc(sizeof(int)*depth);
	__DEBUG2__("initialPredicate", pRoot->CC_str);
	initialPredicate(pRoot->CC_str);
	void **dllHandle=(void**)malloc(sizeof(void*));
	IN_INT_OUT_INT PEVAL=openDLL(dllHandle);
	int stack[128];
	for(i=0;i<(numBlock-1);i++)
	{
		startIndex=i*nlj_blk_size;
		endIndex=(i+1)*nlj_blk_size;
		for(j=0;j<sLen;j++)
		{
			for(col=rNumColumn;col<num_col;col++)
					data[col]=input[col][j].value;
			for(k=startIndex;k<endIndex;k++)
			{
				//if (R[k].value==S[j].value) 
				for(col=0;col<rNumColumn;col++)
					data[col]=input[col][k].value;		
				
				//if(evaluate(data,pRoot, depth))
				//if((data[0]<data[4]) && (data[1]<data[5]) && (data[2]<data[6]) && (data[3]==data[7]))
				//if(evaluate2(data,pRoot, localStack, depth))	
#ifdef NON_LINUX_PLAT
				if(evaluate(data,pRoot, stack,MAX_PREDICATE_NODE))
#else
				if(PEVAL(data))
#endif
				{	
					//r.rid=R[k].rid;
					//r.value=S[j].rid;
					r.rid=input[0][k].rid;
					r.value=input[lastColumn][j].rid;
					ll->fill(&r);
					numResult++;				
				}
			}
		}
		//pcl->getPCL();
	}
	//for the last block.
	startIndex=i*nlj_blk_size;
	endIndex=rLen;
	for(j=0;j<sLen;j++)
	{
		for(col=rNumColumn;col<num_col;col++)
					data[col]=input[col][j].value;
		for(k=startIndex;k<endIndex;k++)
		{
			//if (R[k].value==S[j].value) 
			for(col=0;col<rNumColumn;col++)
					data[col]=input[col][k].value;		
			//if((data[0]==data[2]) && (data[1]<data[3]) )
			//if(evaluate(data,pRoot, MAX_PREDICATE_NODE))			
			//if((data[0]<data[4]) && (data[1]<data[5]) && (data[2]<data[6]) && (data[3]==data[7]))
			//if(evaluate2(data,pRoot, localStack,depth))	
			//if(evaluate(data,pRoot, depth))
#ifdef NON_LINUX_PLAT
				if(evaluate(data,pRoot, stack, MAX_PREDICATE_NODE))
#else
				if(PEVAL(data))
#endif
			{
				r.rid=input[0][k].rid;
				r.value=input[lastColumn][j].rid;
				ll->fill(&r);
				numResult++;
			}
		}
		//pcl->getPCL();
	}
	if(numResult!=0)
	{
		*Rout=(Record*)malloc(sizeof(Record)*numResult);
		ll->copyToArray(*Rout);
	}
	delete ll;
	free(data);
	free(localStack);
	closeDLL(dllHandle);
	return numResult;

}
//the indexed relation is R!!
int cc_inlj(Record *R, int rLen, CC_CSSTree *tree, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout)
{
	__DEBUG__("cc_inlj");
	int result=0;
	int i=0;
	LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
	int k=0;
	int curIndex=0;
	int keyForSearch;
	Record r;
	int data[2];
	for(k=0; k<sLen; k++)
	{
		keyForSearch=S[k].value;
		curIndex=tree->search(keyForSearch);
		data[1]=keyForSearch;
		for(i=curIndex-1;i>0;i--)
		{
			data[0]=R[i].value;
			if(R[i].value==keyForSearch)
			//if(evaluate(data,pRoot, MAX_PREDICATE_NODE))
			{
				r.rid=R[i].rid;
				r.value=S[k].rid;
				ll->fill(&r);
				result++;
			}
			else
				if(R[i].value<keyForSearch)
				break;
		}
		for(i=curIndex;i<rLen;i++)
		{	
			data[0]=R[i].value;
			if(R[i].value==keyForSearch)
			//if(evaluate(data,pRoot, MAX_PREDICATE_NODE))
			{
				r.rid=R[i].rid;
				r.value=S[k].rid;
				ll->fill(&r);
				result++;
			}
			else
				if(R[i].value>keyForSearch)
				break;
		}
	}
	(*Rout)=(Record*)malloc(sizeof(Record)*result);
	ll->copyToArray((*Rout));
	delete ll;
	return result;
}

int cc_smj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout)
{
	__DEBUG__("cc_smj");
	Record **sortedR=(Record**)malloc(sizeof(Record*));
	Record **sortedS=(Record**)malloc(sizeof(Record*));
	cc_quickSort(R,rLen,sortedR,compareRecord);
	cc_quickSort(S,sLen,sortedS,compareRecord);
	int result=co_mergeJoin(*sortedR,rLen,*sortedS,sLen,Rout);
	delete (*sortedR);
	delete (*sortedS);
	free(sortedR);
	free(sortedS);
	return result;
}
//R is the smaller relation.
int cc_simpleHJ(Record *R, int rLen, Record *S, int sLen, Record** Rout)
{
	__DEBUG__("cc_simpleHJ");
	int result=0;
	int bucketID;
	int k=0;
	int i=0;
	int keyForSearch;
	LinkedList *resultLL=(LinkedList*)malloc(sizeof(LinkedList));resultLL->init();
	Record r;
	CCHashTable **htable=(CCHashTable**)malloc(sizeof(CCHashTable*));
	cc_constructHashTable(R, rLen, htable);
	int numBits=(*htable)->numBits;
	int numBuckets=(*htable)->numBuckets;
	for(k=0; k<sLen; k++)
	{
		keyForSearch=S[k].value;
		bucketID=((keyForSearch)&((1<<numBits)-1))%numBuckets;
		if((*htable)->ht[bucketID]!=NULL)
		{
			LinkedList *ll=(*htable)->ht[bucketID];			
			Bucket *sBucket=ll->header;			
			while(sBucket->next!=NULL)
			{
				for(i=0;i<NUM_ENTRY;i++)
				{
					if(sBucket->data[i].value==keyForSearch)
					{
						r.rid=sBucket->data[i].rid;
						r.value=S[k].rid;
						resultLL->fill(&r);
						result++;
					}
				}
				sBucket=sBucket->next;
			}
			//the last bucket
			for(i=0;i<ll->curEntry;i++)
			if(sBucket->data[i].value==keyForSearch)
			{
				r.rid=sBucket->data[i].rid;
				r.value=S[k].rid;
				resultLL->fill(&r);
				result++;
			}
		}
	}
	*Rout=(Record*)malloc(sizeof(Record)*result);
	resultLL->copyToArray(*Rout);
	delete resultLL;
	return result;
}
/*
if both the relations are larger, we use radix join.
*/
int RadixJoin(Record *RR, int rLen, Record *SS, int sLen, Record** Rout)
{
	__DEBUG__("RadixJoin");
	int result=0;
	int totalBits=0;
	int numBuckets=rLen;
	while(numBuckets!=0)
	{
		totalBits++;
		numBuckets=numBuckets/2;
	}
	totalBits=totalBits;
	int lenBits=5;
	int i=0;
	Record* swapR=(Record*)malloc(sizeof(Record)*rLen);
	clock_t l_startTime = clock();
	HashPartition(RR,0,rLen,swapR,swapR,totalBits, lenBits);
	clock_t l_endTime = clock();
	printf("ccp1, %.3f ms, \n",(l_endTime-l_startTime)*1000/ (double)CLOCKS_PER_SEC);
	int pivot=(1<<(totalBits))-1;
	l_startTime = clock();
	Record* swapS=new Record[sLen];
	HashPartition(SS,0,sLen,swapS,swapS,totalBits, lenBits);
	l_endTime = clock();
	printf("ccp2, %.3f ms, \n",(l_endTime-l_startTime)*1000/ (double)CLOCKS_PER_SEC);
	Record *R=swapR;
	Record *S=swapS;	
	l_startTime = clock();
	result=maskMergeJoin(R,rLen,S,sLen,pivot,Rout);
	l_endTime = clock();
	printf("merge, %.3f ms, \n",(l_endTime-l_startTime)*1000/ (double)CLOCKS_PER_SEC);
	
	delete []swapS;
	delete []swapR;
	return result;

}
int cc_hj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout)
{
	__DEBUG__("cc_hj");
	int result=0;
	if(rLen<=L2_CAP/sizeof(Record)/2)
	{
		result=cc_simpleHJ(R,rLen,S,sLen,Rout);
	}
	else
	{
		result=RadixJoin(R,rLen,S,sLen,Rout);
	}
	return result;

}
//pivot is the mask
int maskMergeJoin(Record *R, int rLen, Record* S, int sLen, int pivot, Record **Rout)
{
	int pR=0;
	int pS=0;
	int pS2=0;
	int result=0;
	int pV_R, pV_S;
	LinkedList *resultLL=(LinkedList*)malloc(sizeof(LinkedList));resultLL->init();
	Record r;
	while(pR<rLen && pS<sLen)
	{
		pV_R=(R[pR].value & pivot);
		pV_S=(S[pS].value & pivot);
		if(pV_R==pV_S)
		{
			pS2=pS;
			if(R[pR].value==S[pS].value)
			{
				result++;
				r.rid=R[pR].rid;
				r.value=S[pS].rid;
				resultLL->fill(&r);
			}
			pS2++;
			while (pS2<sLen) {
				if(pV_R==(S[pS2].value & pivot))
				{
					if(R[pR].value==S[pS2].value)
					{
						result++;
						r.rid=R[pR].rid;
						r.value=S[pS2].rid;
						resultLL->fill(&r);
					}
					pS2++;				
				}
				else
				break;
			}
			pR++;
		}
		else
		{
		if(pV_R<pV_S)
			pR++;
		else
			pS++;
		}
	}
	*Rout=(Record*)malloc(sizeof(Record)*result);
	resultLL->copyToArray(*Rout);
	delete resultLL;
	return result;
}
