#ifndef CC_OPERATORS_H
#define CC_OPERATORS_H

#include "db.h"
#include "QueryPlanNode.h"
//selection
int cc_select(Record **Rin, int numColumn, int rLen, PREDICATE_NODE * pRoot, Record **Rout);

//aggregation
int cc_sum(Record *Rin, int rLen);
int cc_avg(Record *Rin, int rLen);
int cc_max(Record *Rin, int rLen);
int cc_min(Record *Rin, int rLen);
int cc_count(Record *Rin, int rLen);
int cc_distinct(Record *Rin, int rLen, int col, Record **output);

//sort
void cc_quickSort(Record *Rin, int rLen, Record **Rout, int (*fcmp)(const void *, const void *));
void cc_radixSort(Record *Rin, int rLen, Record **Rout);
void cc_mergeSort(Record *Rin, int rLen, Record **Rout);
void HashPartition(Record *R, int sR, int eR, Record *dest,Record *swap, int startBits, int lenBits);

//CSS-tree
class CC_CSSTree;
int cc_constructCSSTree(Record *Rin, int rLen, CC_CSSTree **tree);
int cc_equiTreeSearch(Record *Rin, int rLen, CC_CSSTree *tree, int keyForSearch, Record** Rout);
int cc_multi_equiTreeSearch(Record *Rin, int rLen, CC_CSSTree *tree, int* searchKeys, int nKey, Record** Rout);

//hashing 
class CCHashTable;
int cc_constructHashTable(Record *Rin, int rLen, CCHashTable **ht);
int cc_hashSearch(Record *Rin, int rLen, CCHashTable *ht , int keyForSearch, Record** Rout);
int cc_multi_hashSearch(Record *Rin, int rLen, CCHashTable *ht , int* searchKeys, int nKey, Record** Rout);

//join
int cc_ninlj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
int cc_multiNLJ(Record **input,int num_col, int rNumColumn, int rLen,int sLen, PREDICATE_NODE * pRoot, Record ** Rout);
int cc_inlj(Record *R, int rLen, CC_CSSTree *tree, Record *S, int sLen,PREDICATE_NODE * pRoot, Record** Rout);
int cc_smj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
int cc_hj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
#endif

