#include "CC_Operators.h"
#include "LinkedList.h"
#include "db.h"
#include "qpUtility.h"
#include "time.h"
//aggregation
int cc_sum(Record *Rin, int rLen)
{
	__DEBUG__("cc_sum");
	clock_t l_startTime = clock();
	int i=0;
	int result=0;
	for(i=0; i<rLen; i++)
	{
		result+=Rin[i].value;
	}
	clock_t l_endTime = clock();
	printf("time, %.3f ms, \n",(l_endTime-l_startTime)*1000/ (double)CLOCKS_PER_SEC);
	return result;
}
int cc_avg(Record *Rin, int rLen)
{
	__DEBUG__("cc_avg");
	int i=0;
	int result=cc_sum(Rin,rLen);
	if(rLen==0)
		return 0;
	else
		return result/rLen;
}
int cc_max(Record *Rin, int rLen)
{
	__DEBUG__("cc_max");
	int i=0;
	int maxValue=Rin[0].value;
	for(i=1; i<rLen; i++)
	{
		if(maxValue<Rin[i].value)
			maxValue=Rin[i].value;
	}
	return maxValue;
}
int cc_min(Record *Rin, int rLen)
{
	__DEBUG__("cc_min");
	int i=0;
	int minValue=Rin[0].value;
	for(i=1; i<rLen; i++)
	{
		if(minValue>Rin[i].value)
			minValue=Rin[i].value;
	}
	return minValue;
}

int cc_count(Record *Rin, int rLen)
{
	__DEBUG__("cc_count");
	return rLen;
}
int cc_distinct(Record *Rin, int rLen, int col, Record **output)
{
	__DEBUG__("cc_distinct");
	int result=0;
	if(col==0)//rid.
	{
		Record **Rout=(Record**)malloc(sizeof(Record*));
		cc_quickSort(Rin,rLen,Rout,compareRID);
//		LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
		LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList));
		ll->init();
		int i=0;
		int tempValue=Rin[0].rid;
		Record r;
		r.rid=result;
		r.value=(*Rout)[i].rid;
		tempValue=r.rid;
		result++;
		ll->fill(&r);
		for(i=1;i<rLen;i++)
		{
			if((*Rout)[i].rid==tempValue)
				continue;
			else
			{
				r.rid=result;
				r.value=(*Rout)[i].rid;
				result++;
				ll->fill(&r);
				tempValue=(*Rout)[i].rid;
			}
		}
		free(*Rout);
		free(Rout);
		*output=(Record*)malloc(sizeof(Record)*result);
		ll->copyToArray(*output);
		delete ll;
	}
	else
	{		
		Record **Rout=(Record**)malloc(sizeof(Record*));
		cc_quickSort(Rin,rLen,Rout,compareRecord);
		LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList));
		ll->init();
		int i=0;
		int tempValue=Rin[0].value;
		Record r;
		r.rid=result;
		r.value=(*Rout)[i].value;
		tempValue=r.value;
		result++;
		ll->fill(&r);
		for(i=1;i<rLen;i++)
		{
			if((*Rout)[i].value==tempValue)
				continue;
			else
			{
				r.rid=result;
				r.value=(*Rout)[i].value;
				result++;
				ll->fill(&r);
				tempValue=(*Rout)[i].value;
			}
		}
		free(*Rout);
		free(Rout);
		*output=(Record*)malloc(sizeof(Record)*result);
		ll->copyToArray(*output);
		delete ll;
	}
	return result;
}

