#ifndef CO_OPERATORS_H
#define CO_OPERATORS_H

#include "db.h"
#include "QueryPlanNode.h"
//selection
int co_select(Record **Rin, int numColumn, int rLen, PREDICATE_NODE * pRoot, Record **Rout);

//aggregation
int co_sum(Record *Rin, int rLen);
int co_avg(Record *Rin, int rLen);
int co_max(Record *Rin, int rLen);
int co_min(Record *Rin, int rLen);
int co_count(Record *Rin, int rLen);
int co_distinct(Record *Rin, int rLen, int col, Record **output);

//sort
void co_quickSort(Record *Rin, int rLen, Record **Rout, int (*fcmp)(const void *, const void *));
void co_radixSort(Record *Rin, int rLen, Record **Rout);
void BinaryHashPartition(Record *R, int sR, int eR, int startBits);
int SimpleBinaryHashPartition(Record *R, int sR, int eR, int startBits);
//void BinaryRangePartition(Record *R, int sR, int eR, int (*fcmp)(const void *, const void *));
void co_partitionSort(Record *R,int rLen, Record **Rout);
int co_mergeJoin(Record *R, int rLen, Record *S, int sLen, Record** Rout);

//CSS-tree
class VEBTree;
int co_constructCSSTree(Record *Rin, int rLen, VEBTree **tree);
int co_equiTreeSearch(Record *Rin, int rLen, VEBTree *tree, int keyForSearch, Record** Rout);
int co_multi_equiTreeSearch(Record *Rin, int rLen, VEBTree *tree, int* searchKeys, int nKey, Record** Rout);

//hashing 
class COHashTable;
int co_constructHashTable(Record *Rin, int rLen, COHashTable **ht);
int co_hashSearch(Record *Rin, int rLen, COHashTable *ht , int keyForSearch, Record** Rout);
int co_multi_hashSearch(Record *Rin, int rLen, COHashTable *ht , int* searchKeys, int nKey, Record** Rout);

//join
int co_ninlj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
int co_multiNLJ(Record **input,int num_col, int rNumColumn, int rLen,int sLen, PREDICATE_NODE * pRoot, Record ** Rout);
int co_inlj(Record *R, int rLen, VEBTree *tree, Record *S, int sLen,PREDICATE_NODE * pRoot, Record** Rout);
int co_smj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
int co_hj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
int copj(Record *RR, int rLen, Record *SS, int sLen, PREDICATE_NODE * pRoot, Record** Rout);
#endif

