#include "CO_Operators.h"
#include "LinkedList.h"
#include "qpUtility.h"
#include "evaluateFuction.h"


/*
@description: selection on multiple columns. 
			Rout stores the RID of the matching tuples. 
@return: the number of matching tuples.
*/
int co_select(Record **Rin, int numColumn, int rLen, PREDICATE_NODE * pRoot, Record **Rout)
{
	__DEBUG__("co_select");
	int result=0;
	LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
	int *data=new int[numColumn];
	Record r;
	int i=0,j=0;
	__DEBUG2__("initialPredicate", pRoot->CC_str);
	initialPredicate(pRoot->CC_str);
	void **dllHandle=(void**)malloc(sizeof(void*));
	IN_INT_OUT_INT PEVAL=openDLL(dllHandle);
	int stack[128];
	for(i=0;i<rLen;i++)
	{
		for(j=0;j<numColumn;j++)
			data[j]=Rin[j][i].value;
#ifdef NON_LINUX_PLAT
		if(evaluate(data,pRoot, stack, MAX_PREDICATE_NODE))
#else
		if(PEVAL(data))
#endif
		{
			r.rid=i;
			ll->fill(&r);
			result++;
		}
	}	
	*Rout=(Record*)malloc(sizeof(Record)*result);
	ll->copyToArray(*Rout);
	delete ll;
	delete []data;
	return result;
}
