#pragma once

#include "db.h"
//In this class, we implement the array for EaseDB. 
// [rid, a1, a2, a3, ...], all integer fields.
class DBArray
{
public:
	DBArray(void);
	~DBArray(void);
	//the number of attributes, thus, data size= <numAttr+1>*numTuple;
	int numAttr;
	// the data.
	int* data;
	DBArray(int nA, int rLen);
	int numTuple;
	// this function imports the data from file. the first line of the file should be <numAttributes><space><numTuples>
	void importDB(char* dbFile);
	// perform a simple check on the array
	bool check(void);
	// export to a Record array; return the number of tuples.
	int extractToRecord(Record ** R, int attrIndex=1);
	static void transform(DBArray *in, Record *R, int rLen, DBArray *out);
	void init(int nA, int rLen);
};
