#include "MyPCL.h"
extern double s_excludeTime;
#ifdef PCL_LIB
#include <unistd.h>    /* standard unix functions, like alarm()          */
#include <signal.h>    /* signal name macros, and the signal() prototype */
#include "stdlib.h"

//#define MAIN_TEST 1
#ifdef MAIN_TEST
MyPCL * pcl=NULL;
#else
extern MyPCL *pcl;
#endif

/*char *E_name[10]={ 
	"PCL_CYCLES",		"PCL_L2CACHE_MISS",	"PCL_L1DCACHE_MISS",	"PCL_DTLB_MISS",
	"PCL_L2CACHE_HIT",	"PCL_L1ICACHE_MISS",	"PCL_JUMP_UNSUCCESS",	"PCL_JUMP",
	"PCL_IPC",		"PCL_L2DCACHE_MISSRATE"
};

int event[10]={
	PCL_CYCLES,		PCL_L2CACHE_MISS,	PCL_L1DCACHE_MISS,	PCL_DTLB_MISS,
	PCL_L2CACHE_HIT,	PCL_L1ICACHE_MISS,	PCL_JUMP_UNSUCCESS,	PCL_JUMP,
	PCL_IPC,		PCL_L2DCACHE_MISSRATE
};*/
char *E_name[10]={ 
	"PCL_CYCLES",		"PCL_L2CACHE_MISS",	"PCL_L1DCACHE_MISS",	"PCL_DTLB_MISS",
	"PCL_L2CACHE_HIT",	"PCL_L1ICACHE_MISS",	"PCL_JUMP_UNSUCCESS",	"PCL_JUMP",
	"PCL_IPC",		"PCL_L2DCACHE_MISSRATE"
};

int event[10]={
	PCL_CYCLES,		PCL_L2CACHE_MISS,	PCL_L1DCACHE_MISS,	PCL_DTLB_MISS,
	PCL_L2CACHE_HIT,	PCL_L1ICACHE_MISS,	PCL_JUMP_UNSUCCESS,	PCL_JUMP,
	PCL_IPC,		PCL_L2DCACHE_MISSRATE
};


MyPCL::MyPCL(int N)
{
	numEvents=N;
	if(PCLinit(&descr) != PCL_SUCCESS)
	printf("unable to allocate PCL handle\n");
	
	i_result=(PCL_CNT_TYPE*)malloc(sizeof(PCL_CNT_TYPE)*numEvents);
	fp_result=(PCL_FP_CNT_TYPE*)malloc(sizeof(PCL_FP_CNT_TYPE)*numEvents); 
	counter_list=(int *)malloc(sizeof(int)*numEvents);
	total=(double*)malloc(sizeof(double)*numEvents);
	curPeriod=0;
	CYC_Count=0;
	L2_Count=0;
	L1_Count=0;
	TLB_Count=0;
	int i=0;
	for(i=0;i<numEvents; i++)
	{
		counter_list[i] = event[i];//PCL_FP_INSTR;
		total[i]=0;
		oldValue[i]=0;
	}

	/* define in what mode to count (only user mode) */
	flags = PCL_MODE_USER;
}

MyPCL::~MyPCL()
{
	if(PCLexit(descr) != PCL_SUCCESS)
	printf("unable to deallocate PCL handle\n");
	free(i_result);
	free(fp_result);
	free(counter_list);
	free(total);
	
	
}


void MyPCL::OpenPCL()
{
	

	/* query for functionality */
	if ((res = PCLquery(descr, counter_list, numEvents, flags)) != PCL_SUCCESS)
	printf("these two events are not available on this system\n");
	else
	{
	/* start counting */
	if ((res = PCLstart(descr, counter_list, numEvents, flags)) != PCL_SUCCESS)
		{
		printf("problem with starting two events\n");
		exit(1);
		}
		
	}
	CYC_Count=0;
	L2_Count=0;
	L1_Count=0;
	TLB_Count=0;
}



void MyPCL::getPCL()
{
	if ((res = PCLread(descr, i_result, fp_result, numEvents)) != PCL_SUCCESS)
	{
		printf("problem with reading %d events\n",numEvents);
		/*CYC_Count=(float)i_result[0];
		L2_Count=(float)i_result[1];
		L1_Count=(float)i_result[2];
		TLB_Count=(float)i_result[3];*/
		CYC_Count=(float)i_result[0]-oldValue[0];
		L2_Count=(float)i_result[1]-oldValue[1];
		L1_Count=(float)i_result[2]-oldValue[2];
		TLB_Count=(float)i_result[3]-oldValue[3];
		//printf("statistics, period, %d, length, %d, cyc, %.0f,  L2,  %.0f, L1, %.0f, tlb, %.0f\n", curPeriod, PERIOD, CYC_Count[curPeriod], L2_Count[curPeriod],L1_Count[curPeriod],TLB_Count[curPeriod]);
		printf("fail statistics, period, %d, cyc, %.0f,  L2,  %.0f, L1, %.0f, tlb, %.0f\n", curPeriod, (double)i_result[0], (double)i_result[1],(double)i_result[2],(double)i_result[3]);
		for(int i=0;i<numEvents;i++)
			oldValue[i]=(float)i_result[i];
		curPeriod++;
	}
	else
	{
	//read the values;
		
		CYC_Count=(float)i_result[0]-oldValue[0];
		L2_Count=(float)i_result[1]-oldValue[1];
		L1_Count=(float)i_result[2]-oldValue[2];
		TLB_Count=(float)i_result[3]-oldValue[3];
		printf("succefful statistics, period, %d, cyc, %.0f,  L2,  %.0f, L1, %.0f, tlb, %.0f\n", curPeriod, (double)i_result[0], (double)i_result[1],(double)i_result[2],(double)i_result[3]);
		for(int i=0;i<numEvents;i++)
			oldValue[i]=i_result[i];
		curPeriod++;
	}
	
}

double MyPCL::ClosePCL(int numThread)
{
	if ((res = PCLstop(descr, i_result, fp_result, numEvents)) != PCL_SUCCESS)
		printf("problem with stopping two events\n");
	else
	{
		printf("clearing the PCL\n");
		CYC_Count=(float)i_result[0]-oldValue[0];
		L2_Count=(float)i_result[1]-oldValue[1];
		L1_Count=(float)i_result[2]-oldValue[2];
		TLB_Count=(float)i_result[3]-oldValue[3];
		//printf("statistics, period, %d, length, %d, cyc, %.0f,  L2,  %.0f, L1, %.0f, tlb, %.0f\n", curPeriod, PERIOD, CYC_Count[curPeriod], L2_Count[curPeriod],L1_Count[curPeriod],TLB_Count[curPeriod]);
		printf("statistics, period, %d,  cyc, %.0f,  L2,  %.0f, L1, %.0f, tlb, %.0f\n", curPeriod,  (float)i_result[0], (float)i_result[1],(float)i_result[2],(float)i_result[3]);
		for(int i=0;i<numEvents;i++)
			oldValue[i]=i_result[i];
		curPeriod++;
	}
	
}



#else//for mini_second
#include <iostream>
using namespace std;
MyPCL::MyPCL(int N)
{
	numEvents=N;
}

MyPCL::~MyPCL()
{

}

void MyPCL::OpenPCL()
{
	startTime=(double)time(NULL);
	start=startTime+clock()/1000.0;//clock();
}


double MyPCL::ClosePCL(int numThread)
{
	end=startTime+clock()/1000.0;//clock();
		double t=end-start;
	#ifdef SMART_MODE
		cout<<"Time taken, "<<t<<endl;
	#else
	//	cout<<"time, "<<t<<", ";
		cout.setf(ios::fixed); 
		cout.precision(3); 
		cout<<"time, "<<start<<", "<<end<<", "<<t<<", per thread, "<<(t-s_excludeTime)/numThread<<endl;
	#endif
		s_excludeTime=0;
	return t;
	
}

void MyPCL::getPCL()
{
}


#endif


#ifdef MAIN_TEST
#include <iostream>
using namespace std;
int main(int argc, char** argv)
{
	int numEvents=4;
	MyPCL* pcl=new MyPCL(numEvents);
	pcl->OpenPCL();
	int i=0;
	int num=atoi(argv[1])*1024;
	//compare the malloc vs the new method.
	//int *data=new int[num];
	int *data=(int *)malloc(sizeof(int)*num);
	for(int j=0;j<100;j++)
	{
		for(i=0;i<num;i++)
		data[i]=i*j;
		if(j%10==9)
		pcl->getPCL();
	}
	pcl->ClosePCL();
	
	//delete []data;
	free(data);
	
	cout<<"done"<<endl;
}
#endif
