#ifndef ALL_OPERATORS_H
#define ALL_OPERATORS_H

#include "db.h"
#include "QueryPlanNode.h"
//selection
int select(Record **Rin, int numColumn, int rLen, PREDICATE_NODE * pRoot, Record **Rout, bool mode=CC_EXEC);

//aggregation
int sum(Record *Rin, int rLen, bool mode=CC_EXEC);
int avg(Record *Rin, int rLen, bool mode=CC_EXEC);
int max(Record *Rin, int rLen, bool mode=CC_EXEC);
int min(Record *Rin, int rLen, bool mode=CC_EXEC);
int count(Record *Rin, int rLen, bool mode=CC_EXEC);
int distinct(Record *Rin, int rLen, int col, Record **output, bool mode=CC_EXEC);

//sort
void sort(Record *R,int rLen, Record **Rout, int (*fcmp)(const void *, const void *), bool mode=CC_EXEC);


int constructCSSTree(Record *Rin, int rLen, void **tree, bool mode=CC_EXEC);
int equiTreeSearch(Record *Rin, int rLen, void *tree, int keyForSearch, Record** Rout, bool mode=CC_EXEC);
int multi_equiTreeSearch(Record *Rin, int rLen, void *tree, int* searchKeys, int nKey, Record** Rout, bool mode=CC_EXEC);

int constructHashTable(Record *Rin, int rLen, void **ht, bool mode=CC_EXEC);
int hashSearch(Record *Rin, int rLen, void *ht , int keyForSearch, Record** Rout, bool mode=CC_EXEC);
int multi_hashSearch(Record *Rin, int rLen, void *ht , int* searchKeys, int nKey, Record** Rout, bool mode=CC_EXEC);

//join
int ninlj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout, bool mode=CC_EXEC);
int multiNLJ(Record **input,int num_col, int rNumColumn, int rLen,int sLen, PREDICATE_NODE * pRoot, Record ** Rout,bool execMode);
int inlj(Record *R, int rLen, void *tree, Record *S, int sLen,PREDICATE_NODE * pRoot, Record** Rout, bool mode=CC_EXEC);
int smj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout, bool mode=CC_EXEC);
int hj(Record *R, int rLen, Record *S, int sLen, PREDICATE_NODE * pRoot, Record** Rout, bool mode=CC_EXEC);
int mergeJoin(Record *R, int rLen, Record *S, int sLen, Record** Rout, bool mode=CC_EXEC);
int maskMergeJoin(Record *R, int rLen, Record* S, int sLen, int pivot, Record **Rout);
#endif

