#ifndef PN_BUFFER_H
#define PN_BUFFER_H

#include "stdio.h"
#include "db.h"
#include "stdlib.h"

#define LARGE_NUM_ENTRY 4096
#define SMALL_NUM_ENTRY 4

class Buffer
{
public:
	Buffer()
	{}
	virtual void fill(Record *r)=0;
};

class VarBuffer:public Buffer
{
public:
	int search(int value)
	{
		int result=0;
		Bucket *sBucket=header;
		int i=0;	
		int bucket;
		for(bucket=0;bucket<numBuckets;bucket++)
		//while(sBucket->next!=NULL)
		{
			for(i=0;i<NUM_ENTRY;i++)
				if(sBucket->data[i].value==value)
					result++;
			sBucket=sBucket->next;
		}
		//the last bucket
		for(i=0;i<curEntry;i++)
			if(sBucket->data[i].value==value)
					result++;	
		return result;
	}
	VarBuffer()
	{
	//	size=0;		
		header=newBucket=(Bucket*)malloc(sizeof(Bucket));
		header->init();
		curEntry=0;
		numBuckets=0;
	}
	~VarBuffer()
	{
		Bucket *b=header;
		Bucket *bnext=header;
		while(bnext!=NULL)
		{
			bnext=b->next;
			//delete b;
			b=bnext;
		}
	}
	Bucket* header;
	Bucket* newBucket;
	int curEntry;
	int numBuckets;

	int size()
	{
		return (numBuckets*NUM_ENTRY)+curEntry;
	}
	
	
	inline void fill(Record *r)
	{
	//	size++;
		if(curEntry==NUM_ENTRY)
		{
			if(newBucket->next==NULL)
			newBucket->next=(Bucket*)malloc(sizeof(Bucket));
			newBucket->init();
			newBucket=newBucket->next;
			//newBucket->data[0].rid=r->rid;
			//newBucket->data[0].value=r->value;
			EVAL((newBucket->data),r);
			//memcpy(newBucket->data+curEntry,r,sizeof(Record));
			curEntry=1;
			numBuckets++;
		}
		else
		{	
			//newBucket->data[curEntry].rid=r->rid;
			//newBucket->data[curEntry].value=r->value;
			EVAL((newBucket->data+curEntry),r);
			//memcpy(newBucket->data+curEntry,r,sizeof(Record));
			curEntry++;
		}

	}

	void print(int mask)
	{
		Bucket *sBucket=header;
		int i=0;
		while(sBucket->next!=NULL)
		{
			for(i=0;i<NUM_ENTRY;i++)
				cout<<sBucket->data[i].value<<"/"<<(sBucket->data[i].value & mask)<<", ";
			sBucket=sBucket->next;
		}
		//the last bucket
		for(i=0;i<curEntry;i++)
			cout<<sBucket->data[i].value<<"/"<<(sBucket->data[i].value & mask)<<", ";
		cout<<endl;

	}

	void print(int moveBits,int mask)
	{
		Bucket *sBucket=header;
		int i=0;
		while(sBucket->next!=NULL)
		{
			for(i=0;i<NUM_ENTRY;i++)
				cout<<sBucket->data[i].value<<"/"<<((sBucket->data[i].value>>moveBits) & mask)<<", ";
			sBucket=sBucket->next;
		}
		//the last bucket
		for(i=0;i<curEntry;i++)
			cout<<sBucket->data[i].value<<"/"<<((sBucket->data[i].value>>moveBits) & mask)<<", ";
		cout<<endl;

	}
	
};


class SmallBucket{
public:
	Record data[SMALL_NUM_ENTRY];
	SmallBucket *next;
	SmallBucket()
	{
		next=NULL;
	}
};
class SmallVarBuffer:public Buffer
{
public:
	SmallVarBuffer()
	{
	//	size=0;		
		header=newBucket=new SmallBucket();
		curEntry=0;
	}
	int size(){return 0;}
	
	SmallBucket* header;
	SmallBucket* newBucket;
	int curEntry;
	
	inline void fill(Record *r)
	{
	//	size++;
		if(curEntry==SMALL_NUM_ENTRY)
		{
			if(newBucket->next==NULL)
			newBucket->next=new SmallBucket();
			newBucket=newBucket->next;
			EVAL((newBucket->data),r);
			curEntry=1;
		}
		else
		{
			EVAL((newBucket->data+curEntry),r);
			curEntry++;
		}

	}
	
	int search(int value)
	{
		int result=0;
		SmallBucket *sBucket=header;
		int i=0;
		while(sBucket->next!=NULL)
		{
			for(i=0;i<SMALL_NUM_ENTRY;i++)
				if(sBucket->data[i].value==value)
					result++;
			sBucket=sBucket->next;
		}
		//the last bucket
		for(i=0;i<curEntry;i++)
			if(sBucket->data[i].value==value)
					result++;	
		return result;

	}
	void print(int mask)
	{
		SmallBucket *sBucket=header;
		int i=0;
		while(sBucket->next!=NULL)
		{
			for(i=0;i<SMALL_NUM_ENTRY;i++)
				cout<<sBucket->data[i].value<<"/"<<(sBucket->data[i].value & mask)<<", ";
			sBucket=sBucket->next;
		}
		//the last bucket
		for(i=0;i<curEntry;i++)
			cout<<sBucket->data[i].value<<"/"<<(sBucket->data[i].value & mask)<<", ";
		cout<<endl;

	}

	void print(int moveBits,int mask)
	{
		SmallBucket *sBucket=header;
		int i=0;
		while(sBucket->next!=NULL)
		{
			for(i=0;i<SMALL_NUM_ENTRY;i++)
				cout<<sBucket->data[i].value<<"/"<<((sBucket->data[i].value>>moveBits) & mask)<<", ";
			sBucket=sBucket->next;
		}
		//the last bucket
		for(i=0;i<curEntry;i++)
			cout<<sBucket->data[i].value<<"/"<<((sBucket->data[i].value>>moveBits) & mask)<<", ";
		cout<<endl;

	}
	
};


class LargeBucket{
public:
	Record data[LARGE_NUM_ENTRY];
	LargeBucket *next;
	LargeBucket()
	{
		next=NULL;
	}
};

class LargeVarBuffer:public Buffer
{
public:
	LargeVarBuffer(int numSeg)
	{
		header=newBucket=new LargeBucket();
		LargeBucket *cur=header;
		for(int i=1;i<numSeg;i++)
		{
			cur->next=new LargeBucket();
			cur=cur->next;
		}
		curEntry=0;
		numBucket=0;
	}
	LargeBucket* header;
	LargeBucket* newBucket;
	int curEntry;
	//only count the complete full buckets. 
	int numBucket;
	

	inline void fill(Record *r)
	{
		if(curEntry==LARGE_NUM_ENTRY)
		{
			if(newBucket->next==NULL)
			newBucket->next=new LargeBucket();
			newBucket=newBucket->next;
			//newBucket->data[0].rid=r->rid;
			//newBucket->data[0].value=r->value;
			EVAL((newBucket->data),r);
			//memcpy(newBucket->data+curEntry,r,sizeof(Record));
			curEntry=1;
			numBucket++;
		}
		else
		{	
			//newBucket->data[curEntry].rid=r->rid;
			//newBucket->data[curEntry].value=r->value;
			EVAL((newBucket->data+curEntry),r);
			//memcpy(newBucket->data+curEntry,r,sizeof(Record));
			curEntry++;
		}

	}

	
	
};


#endif

