#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "PredicateTree.h"
#include "qpUtility.h"

int evaluate(int * row, PREDICATE_NODE * root)
{
	int t1, t2;
	
	if (root->left == NULL && root->right == NULL)
	{
		if (root->opt[0] == '#')
			return row[atoi(root->opt + 1)];
		else
			return atoi(root->opt);
	}

	t1 = evaluate(row, root->left);
	t2 = evaluate(row, root->right);
	if (strcmp(root->opt, "AND") == 0)
		return t1 && t2;
	if (strcmp(root->opt, "OR") == 0)
		return t1 || t2;
	if (strcmp(root->opt, "=") == 0)
		return t1 == t2;
	if (strcmp(root->opt, ">") == 0)
		return t1 > t2;
	if (strcmp(root->opt, "<") == 0)
		return t1 < t2;
	if (strcmp(root->opt, ">=") == 0)
		return t1 >= t2;
	if (strcmp(root->opt, "<=") == 0)
		return t1 <= t2;
	if (strcmp(root->opt, "<>") == 0)
		return t1 != t2;
	return 0;
}

PREDICATE_NODE * construct_predicate_tree(char * str, int * index, char c[][20], int num)
{
	int i, k, j = *index;
	PREDICATE_NODE * node = new PREDICATE_NODE;

	for (i = j; str[i] != '\0'; i++)
	{
		if (str[i] == ';')
			break;
		node->opt[i - j] = str[i];
	}
	node->opt[i - j] = '\0';
	i++;
	//rename the column
	for (k = 0; k < num; k++)
		if (strcmp(node->opt, c[k]) == 0)
		{
			node->opt[0] = '#';
			linux_itoa(k, node->opt + 1, 19);
			break;
		}

	//recursive
	if (strcmp(node->opt, "NIL") == 0)
	{
		delete node;
		node = NULL;
	}
	else
	{
		node->left = construct_predicate_tree(str, &i, c, num);
		node->right = construct_predicate_tree(str, &i, c, num);
	}
	*index = i;
	return node;
}

void delete_predicate_tree(PREDICATE_NODE * node)
{
	if (node == NULL)
		return;
	delete_predicate_tree(node->left);
	delete_predicate_tree(node->right);
	delete node;
}

int test_predicate_tree()
{
	int i = 0;
	char a[] = "OR;AND;=;A.a;NIL;NIL;A.b;NIL;NIL;=;A.c;NIL;NIL;1;NIL;NIL;<;A.a;NIL;NIL;2;NIL;NIL";
//	char a[] = "OR;AND;=;#1;NIL;NIL;#2;NIL;NIL;=;#3;NIL;NIL;1;NIL;NIL;<;#1;NIL;NIL;2;NIL;NIL";
	int b[] = {2, 1, 1};
	char c[][20] = {"A.a", "A.b", "A.c"};
	int num = 3;

	PREDICATE_NODE * root = construct_predicate_tree(a, &i, c, num);
	int res = evaluate(b, root);
	printf("%d\n", res);

	return 0;
}
