#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "QueryPlanNode.h"
#include "QueryPlanTree.h"
#include "UInterface.h"
#include "qpUtility.h"
#include "time.h"
#include <iostream>
using namespace std;

#define OPT_NUM	0
#define OPT_COL	1
#define OPT_OTHER 2

#define CMP_BIGER 3
#define CMP_SMALLER 4
#define CMP_OTHER 5


void QueryPlanNode::initialNode(char * str, ExecStatus *status, bool mode)
{
	planStatus=status;
	execMode=mode;

	int i = 0, j, k;

	if (str[0] == '$')
		return;

	for (j = i; str[j] != ';'; j++);
	str[j] = '\0';
	if (strcmp(str, "SEL") == 0)
		opt = TYPE_SELECTION;
	else if (strcmp(str, "JOIN") == 0)
		opt = TYPE_JOIN;
	else if (strcmp(str, "PRO") == 0)
		opt = TYPE_PROJECTION;
	else if (strcmp(str, "AGG") == 0)
		opt = TYPE_AGGREGATION;
	else if (strcmp(str, "ORD") == 0)
		opt = TYPE_ORD;

	i = j + 1;

	for (j = i; str[j] != ';'; j++);
	str[j] = '\0';
	//table1 = new char[j - i + 1];
	table1=(char*)malloc(sizeof(char)*(j - i + 1));
	strcpy(table1, str + i);
	i = j + 1;

	for (j = i; str[j] != ';'; j++);
	str[j] = '\0';
	//table2 = new char[j - i + 1];
	table2=(char*)malloc(sizeof(char)*(j - i + 1));
	strcpy(table2, str + i);

	int num = 0;
	i = j + 1;
	for (j = i; str[j] != ';'; j++)
		if (str[j] == ',')
			num++;
	num_col = num;
	//columns = new char * [num];
	columns=(char**)malloc(sizeof(char*)*num);
	for (k = 0; k < num; k++)
	{
		for (j = i; str[j] != ','; j++);
		str[j] = '\0';
		//columns[k] = new char[j - i + 1];
		columns[k]=(char*)malloc(sizeof(char)*(j - i + 1));
		strcpy(columns[k], str + i);
		i = j + 1;
	}
	i++;

	k = 0;
//	int length = strlen(str + i);
//	char * tempstr = new char[length + 1];
//	strcpy(tempstr, str + i);
//	nodeArray = construct_predicate_tree(str + i);

	predicateRoot = new PREDICATE_NODE;
	predicateRoot->root = construct_predicate_tree(str + i, &k);

	predicateRoot->GPU_str = get_GPU_predicate_string(predicateRoot->root);
//	printf("%s\n", predicateRoot->GPU_str);
	
	predicateRoot->CC_str = get_CC_predicate_string(predicateRoot->root);
//	printf("%s\n", predicateRoot->CC_str);

	predicateRoot->array = new PREDICATE_ARRAY_NODE[MAX_PREDICATE_NODE];
	int length = construct_predicate_array(predicateRoot->root, 0);
	predicateRoot->array[length].flag = PREDICATE_END;

	type = checkType();
}

char * QueryPlanNode::get_GPU_predicate_string(_PREDICATE_NODE * root)
{
	int len;
	//char * str = new char [MAX_PREDICATE_STRING];
	char * str = (char*)malloc(sizeof(char)*MAX_PREDICATE_STRING);

	len = construct_GPU_predicate_string(root, str);
	str[len] = '\0';
	return str;
}

char * QueryPlanNode::get_CC_predicate_string(_PREDICATE_NODE * root)
{
	int len;
	//char * str = new char [MAX_PREDICATE_STRING];
	char * str = (char*)malloc(sizeof(char)*MAX_PREDICATE_STRING);
	len = construct_CC_predicate_string(root, str);
	str[len] = '\0';
	return str;
}

int QueryPlanNode::construct_GPU_predicate_string(_PREDICATE_NODE * root, char * str)
{
	int index = 0;

	if (root == NULL)
		return 0;

	if (root->left == NULL && root->right == NULL)
	{
		if (root->opt[0] == '#')
		{
			str[0] = 'c';
			str[1] = 'o';
			str[2] = 'l';
			strcpy(str + 3, root->opt + 1);
			return 3 + (int)strlen(root->opt + 1);
		}
		else
		{
			strcpy(str, root->opt);
			return (int)strlen(root->opt);
		}
	}
	else
	{
		str[index++] = '(';
		index += construct_GPU_predicate_string(root->left, str + index);
		str[index++] = ')';
		if (strcmp(root->opt, "AND") == 0)
		{
			str[index++] = '&';
			str[index++] = '&';
		}
		else if (strcmp(root->opt, "OR") == 0)
		{
			str[index++] = '|';
			str[index++] = '|';
		}
		else if (strcmp(root->opt, ">=") == 0)
		{
			str[index++] = '>';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, "<=") == 0)
		{
			str[index++] = '<';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, "<>") == 0)
		{
			str[index++] = '!';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, "=") == 0)
		{	
			str[index++] = '=';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, ">") == 0)
			str[index++] = '>';
		else if (strcmp(root->opt, "<") == 0)
			str[index++] = '<';
		
		
		str[index++] = '(';
		index += construct_GPU_predicate_string(root->right, str + index);
		str[index++] = ')';
		return index;
	}

}

int QueryPlanNode::construct_CC_predicate_string(_PREDICATE_NODE * root, char * str)
{
	int index = 0;

	if (root == NULL)
		return 0;

	//printf("con_str: %s\n", root->opt);
	
	if (root->left == NULL && root->right == NULL)
	{
		if (root->opt[0] == '#')
		{
			strcpy(str, "data[");
			strcpy(str + 5, root->opt + 1);
			int length = (int)strlen(str);
			str[length] = ']';
			return length + 1;
		}
		else
		{
			strcpy(str, root->opt);
			return (int)strlen(root->opt);
		}
	}
	else
	{
		str[index++] = '(';
		index += construct_CC_predicate_string(root->left, str + index);
		str[index++] = ')';
		if (strcmp(root->opt, "AND") == 0)
		{
			str[index++] = '&';
			str[index++] = '&';
		}
		else if (strcmp(root->opt, "OR") == 0)
		{
			str[index++] = '|';
			str[index++] = '|';
		}
		else if (strcmp(root->opt, ">=") == 0)
		{
			str[index++] = '>';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, "<=") == 0)
		{
			str[index++] = '<';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, "<>") == 0)
		{
			str[index++] = '!';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, "=") == 0)
		{	
			str[index++] = '=';
			str[index++] = '=';
		}
		else if (strcmp(root->opt, ">") == 0)
			str[index++] = '>';
		else if (strcmp(root->opt, "<") == 0)
			str[index++] = '<';
		
		str[index++] = '(';
		index += construct_CC_predicate_string(root->right, str + index);
		str[index++] = ')';
		return index;
	}
}

int QueryPlanNode::construct_predicate_array(_PREDICATE_NODE * root, int index)
{
	if (root == NULL)
		return index;

	if (root->left)
		index = construct_predicate_array(root->left, index);
	if (root->right)
		index = construct_predicate_array(root->right, index);
	
	if (strcmp(root->opt, "AND") == 0)
		predicateRoot->array[index].flag = PREDICATE_AND;
	else if (strcmp(root->opt, "OR") == 0)
		predicateRoot->array[index].flag = PREDICATE_OR;
	else if (strcmp(root->opt, "=") == 0)
		predicateRoot->array[index].flag = PREDICATE_EQUAL;
	else if (strcmp(root->opt, ">") == 0)
		predicateRoot->array[index].flag = PREDICATE_BIG;
	else if (strcmp(root->opt, "<") == 0)
		predicateRoot->array[index].flag = PREDICATE_SMALL;
	else if (strcmp(root->opt, ">=") == 0)
		predicateRoot->array[index].flag = PREDICATE_NOTSMALL;
	else if (strcmp(root->opt, "<=") == 0)
		predicateRoot->array[index].flag = PREDICATE_NOTBIG;
	else if (strcmp(root->opt, "<>") == 0)
		predicateRoot->array[index].flag = PREDICATE_NOTEQUAL;
	else if (root->opt[0] == '#')
	{
		predicateRoot->array[index].flag = PREDICATE_COL;
		predicateRoot->array[index].val = atoi(root->opt + 1);
	}
	else
	{
		predicateRoot->array[index].flag = PREDICATE_NUM;
		predicateRoot->array[index].val = atoi(root->opt);
	}
	return index + 1;
}



int QueryPlanNode::checkType()
{
	int t1, t2;

	if (predicateRoot == NULL)
		return TYPE_UNKNOWN;

	int leftopt;
	int rightopt;
	
	if (opt == TYPE_SELECTION)
	{
		if (strcmp(predicateRoot->root->opt, "=") == 0)
		{
			leftopt = getOperandType(predicateRoot->root->left->opt);
			rightopt = getOperandType(predicateRoot->root->right->opt);
			if ((leftopt == OPT_COL && rightopt == OPT_NUM)
				|| (leftopt == OPT_NUM && rightopt == OPT_COL))
				return TYPE_SEL_EQUAL;
		}
		if (strcmp(predicateRoot->root->opt, "AND") == 0)
		{
			char * t1col, * t1num, *t2col, *t2num;
			t1 = getCompare(predicateRoot->root->left, &t1col, &t1num);
			t2 = getCompare(predicateRoot->root->right, &t2col, &t2num);
			if (((t1 == CMP_BIGER && t2 == CMP_SMALLER) || (t1 == CMP_SMALLER && t2 == CMP_BIGER))
				&& strcmp(t1col, t2col) == 0)
				return TYPE_SEL_BAND;
		}
		return TYPE_SEL_OTHER;
	}
	if (opt == TYPE_JOIN)
	{
		if (strcmp(predicateRoot->root->opt, "=") == 0)
		{
			leftopt = getOperandType(predicateRoot->root->left->opt);
			rightopt = getOperandType(predicateRoot->root->right->opt);
			if (leftopt == OPT_COL && rightopt == OPT_COL)
				return TYPE_JOIN_EQUAL;
		}
		return TYPE_JOIN_OTHER;
	}
	return TYPE_UNKNOWN;
}

int QueryPlanNode::getCompare(_PREDICATE_NODE * node, char ** col, char ** num)
{
	char * str = node->opt;
	int t1, t2;

	if (strcmp(str, ">") == 0 || strcmp(str, ">=") == 0)
	{
		t1 = getOperandType(node->left->opt);
		t2 = getOperandType(node->right->opt);
		if (t1 == OPT_COL && t2 == OPT_NUM)
		{
			*col = node->left->opt;
			*num = node->right->opt;
			return CMP_BIGER;
		}
		if (t1 == OPT_NUM && t2 == OPT_COL)
		{
			*col = node->right->opt;
			*num = node->left->opt;
			return CMP_SMALLER;
		}
		return CMP_OTHER;
	}
	if (strcmp(str, "<") == 0 || strcmp(str, "<=") == 0)
	{
		t1 = getOperandType(node->left->opt);
		t2 = getOperandType(node->right->opt);
		if (t1 == OPT_COL && t2 == OPT_NUM)
		{
			*col = node->left->opt;
			*num = node->right->opt;
			return CMP_SMALLER;
		}
		if (t1 == OPT_NUM && t2 == OPT_COL)
		{
			*col = node->right->opt;
			*num = node->left->opt;
			return CMP_BIGER;
		}
		return CMP_OTHER;
	}
	return CMP_OTHER;
}

int QueryPlanNode::getOperandType(char * str)
{
	int i;
	bool hasLetter = false;

	if (str[0] == '#')
		return OPT_COL;

	for (i = 0; str[i] != '\0'; i++)
	{
		if (str[i] < '0' || str[i] > '9')
			hasLetter = true;
	}
	if (hasLetter)
		return OPT_OTHER;
	else
		return OPT_NUM;
}


_PREDICATE_NODE * QueryPlanNode::construct_predicate_tree(char * str, int * index)
{
	int i, k, j = *index;
	_PREDICATE_NODE * node = new _PREDICATE_NODE;

	if (str[j] == '$')
	{
		*index = j + 2;
		return NULL;
	}


	for (i = j; str[i] != ','; i++);
	str[i] = '\0';
	node->opt = new char [i - j + 1];
	strcpy(node->opt, str + j);
	i++;

	//rename the column
	for (k = 0; k < num_col; k++)
		if (strcmp(node->opt, columns[k]) == 0)
		{
			node->opt[0] = '#';
			linux_itoa(k, node->opt + 1, 10);
			break;
		}

	//recursive
	if (strcmp(node->opt, "$") == 0)
	{
		delete node;
		node = NULL;
	}
	else
	{
		node->left = construct_predicate_tree(str, &i);
		node->right = construct_predicate_tree(str, &i);
	}
	*index = i;
	return node;
}

/*
PREDICATE_NODE * QueryPlanNode::construct_predicate_tree(char * str)
{
	int i, k, j = 0, m, index;

	if (str[0] == '$')
		return NULL;

	predicate_num = 0;
	for (i = 0; str[i] != ';'; i++)
		if (str[i] == ',')
			predicate_num++;

	PREDICATE_NODE * node = new PREDICATE_NODE[predicate_num + 1];

	for (m = 0, index = 0; m < predicate_num; m++)
	{
		for (i = j; str[i] != ','; i++);
		str[i] = '\0';
		if (strcmp(str + j, "$") == 0)
		{
			j = i + 1;
			continue;
		}

		if (strcmp(str + j, "AND") == 0)
			node[index].flag = PREDICATE_AND;
		else if (strcmp(str + j, "OR") == 0)
			node[index].flag = PREDICATE_OR;
		else if (strcmp(str + j, "=") == 0)
			node[index].flag = PREDICATE_EQUAL;
		else if (strcmp(str + j, ">") == 0)
			node[index].flag = PREDICATE_BIG;
		else if (strcmp(str + j, "<") == 0)
			node[index].flag = PREDICATE_SMALL;
		else if (strcmp(str + j, ">=") == 0)
			node[index].flag = PREDICATE_NOTSMALL;
		else if (strcmp(str + j, "<=") == 0)
			node[index].flag = PREDICATE_NOTBIG;
		else if (strcmp(str + j, "<>") == 0)
			node[index].flag = PREDICATE_NOTEQUAL;
		else
		{
			//rename the column
			for (k = 0; k < num_col; k++)
				if (strcmp(str + j, columns[k]) == 0)
				{
					node[index].flag = PREDICATE_COL;
					node[index].val = k;
					break;
				}

			if (k >= num_col)
			{
				node[index].flag = PREDICATE_NUM;
				node[index].val = atoi(str + j);
			}
		}
		j = i + 1;
		index ++;
	}
	predicate_num = index;
	node[predicate_num].flag = PREDICATE_END;

	return node;
}
*/

void QueryPlanNode::delete_predicate_tree(PREDICATE_NODE * node)
{
	delete [] node;
}

void QueryPlanNode::execute(int nodeLevel)
{
	
	if (left != NULL)
	{
		left->execute(nodeLevel+1);
	}
	if (right != NULL)
	{
		right->execute(nodeLevel+1);
	}
	clock_t l_startTime = clock();
	//execute the current node
	switch(opt)
	{
	case TYPE_SELECTION:
		{
			//printf("selection on %s\n", table1);
			__DEBUG2__("selection on",table1);
			int res;
			int tableID=planStatus->getBaseTable(table1);
			Record **Rout=(Record**)malloc(sizeof(Record*));
			int *RIDout=NULL;
			if(tableID==-1)//not in the query plan tree
			{
				res = uSelectOnBaseTable(table1, columns, num_col, predicateRoot, Rout,execMode);
				RIDout=(int*)malloc(sizeof(int)*res);
				getRIDs(*Rout,res,0, RIDout,execMode);
				planStatus->addBaseTable(table1,RIDout,res);
			}
			else
			{
				int *RID=planStatus->RID_baseTable[tableID];
				int rLen=planStatus->RIDLen[tableID];
				res=uSelectOnInterMediateTable(RID, rLen, table1, columns, num_col, predicateRoot, Rout,execMode);
				free(RID);
				RIDout=(int*)malloc(sizeof(int)*res);
				getRIDs(*Rout,res,0, RIDout,execMode);
				planStatus->RID_baseTable[tableID]=RIDout;
				planStatus->RIDLen[tableID]=res;
			}		
		}
		break;
	case TYPE_JOIN:
		{
			int i;
			//printf("join on %s and %s\n", table1, table2);
			__DEBUG3__("join on",table1,table2);
			int res;
			int tableID_1=planStatus->getBaseTable(table1);
			Record **Rout=(Record**)malloc(sizeof(Record*)*this->num_col);
			int *RIDout_1=NULL;
			int rLen_1;
			int newTable[2];//indicate whether the table is new.
			int numColumnForTable[2];
			bool first=true;
			int strLen=(int)strlen(table1);
			numColumnForTable[0]=0;
			if(tableID_1==-1)//not in the query plan tree
			{				
				for(i=0;i<this->num_col;i++)
				{
					if(strncmp(columns[i],table1,strLen)==0)
					{
						numColumnForTable[0]++;
						//select all the RIDs.						
						if(first)
						{
							rLen_1=rSelectBaseTable(table1, columns[i], &(Rout[i]),execMode);
							newTable[0]=1;
							RIDout_1=(int*)malloc(sizeof(int)*rLen_1);
							getRIDs(Rout[i],rLen_1,0, RIDout_1,execMode);
							tableID_1=planStatus->addBaseTable(table1,RIDout_1,rLen_1);
							first=false;
						}
						else
						{
							Rout[i]=(Record*)malloc(sizeof(Record)*rLen_1);
							rSelect(table1,columns[i],RIDout_1,rLen_1,Rout[i],execMode);							
						}
					}
				}
			}
			else
			{
				newTable[0]=0;
				for(i=0;i<this->num_col;i++)
				{
					if(strncmp(columns[i],table1,strLen)==0)
					{
						numColumnForTable[0]++;
						RIDout_1=planStatus->RID_baseTable[tableID_1];
						rLen_1=planStatus->RIDLen[tableID_1];
						Rout[i]=(Record*)malloc(sizeof(Record)*rLen_1);
						rSelect(table1,columns[i],RIDout_1,rLen_1,Rout[i],execMode);			
					}
				}
						
			}
#ifdef DEBUG
			cout<<table1<<"*"<<rLen_1<<endl;
			for(i=0;i<rLen_1;i++)
			{
				cout<<Rout[0][i].rid<<", ";
				if(i>10) break;
			}
#endif
			//get table2
			int tableID_2=planStatus->getBaseTable(table2);
			//Record **Rout_2=(Record**)malloc(sizeof(Record*)*this->num_col);
			int *RIDout_2=NULL;
			int rLen_2;
			strLen=(int)strlen(table2);
			numColumnForTable[1]=0;
			first=true;
			if(tableID_2==-1)//not in the query plan tree
			{
				for(i=0;i<this->num_col;i++)
				{
					if(strncmp(columns[i],table2,strLen)==0)
					{
						numColumnForTable[1]++;
						//select all the RIDs.						
						if(first)
						{
							rLen_2=rSelectBaseTable(table2, columns[i], &(Rout[i]),execMode);
							newTable[1]=1;
							RIDout_2=(int*)malloc(sizeof(int)*rLen_2);
							getRIDs(Rout[i],rLen_2,0, RIDout_2,execMode);
							tableID_2=planStatus->addBaseTable(table2,RIDout_2,rLen_2);
							first=false;
						}
						else
						{
							Rout[i]=(Record*)malloc(sizeof(Record)*rLen_2);
							rSelect(table2,columns[i],RIDout_2,rLen_2,Rout[i],execMode);							
						}
					}
				}
			}
			else
			{
				newTable[1]=0;
				for(i=0;i<this->num_col;i++)
				{
					if(strncmp(columns[i],table2,strLen)==0)
					{
						numColumnForTable[1]++;
						RIDout_2=planStatus->RID_baseTable[tableID_2];
						rLen_2=planStatus->RIDLen[tableID_2];
						Rout[i]=(Record*)malloc(sizeof(Record)*rLen_2);
						rSelect(table2,columns[i],RIDout_2,rLen_2,Rout[i],execMode);			
					}
				}
			}
#ifdef DEBUG
			cout<<table2<<endl;
			for(i=0;i<rLen_2;i++)
			{
				cout<<Rout[numColumnForTable[0]][i].rid<<", ";		
				if(i>10) break;
			}
#endif
			//the join.
			Record **result=(Record **)malloc(sizeof(Record*));
			if(this->num_col==2)
				res=uJoin(table1, columns[0], Rout[0],rLen_1,table2, columns[1], Rout[1],rLen_2, predicateRoot, this->type, result,execMode);
			else
				res=uNLJ(Rout,num_col, numColumnForTable[0], rLen_1,rLen_2, predicateRoot, result,execMode);
#ifdef DEBUG
			if(res!=0) 
			{
				cout<<"!!!!!~"<<res<<endl;
				for(int j=0;j<res;j++)
				{
					cout<<(*result)[j].rid<<", "<<(*result)[j].value<<"\t";
					if(j>10) break;
				}
				cout<<endl;
				
			}
#endif
			for(i=0;i<num_col;i++)
				free(Rout[i]);
			
			//one of the table should be new
			int* joinRID_1=(int*)malloc(sizeof(int)*res);
			if(newTable[0]==1)//it is new.
			{
				//new table, just dump the result RID list ot the result
				getRIDs(*result,res, 0, joinRID_1,execMode);
			}
			else
			{
				//generate the RID list of original table from the join results
				genOriginalRIDs(RIDout_1,*result,res, 0, joinRID_1,execMode);
				for(int i=0;i<planStatus->numTables;i++)
				{
					if(i!=tableID_1 && i!=tableID_2)
					{
						int* tRIDout=planStatus->RID_baseTable[i];
						int* joinRID=(int*)malloc(sizeof(int)*res);
						genOriginalRIDs(tRIDout,*result,res, 0, joinRID,execMode);
						planStatus->RID_baseTable[i]=joinRID;
						planStatus->RIDLen[i]=res;
						free(tRIDout);
					}                    					
				}
			}
			//update the status of the query plan.
			RIDout_1=planStatus->RID_baseTable[tableID_1];
			free(RIDout_1);
			planStatus->RID_baseTable[tableID_1]=joinRID_1;
			planStatus->RIDLen[tableID_1]=res;
			
			//for table2
			int* joinRID_2=(int*)malloc(sizeof(int)*res);
			if(newTable[1]==1)
			{
				//new table, just dump the result RID list ot the result
				getRIDs(*result,res, 1, joinRID_2,execMode);
			}
			else
			{
				//generate the RID list of original table from the join results
				genOriginalRIDs(RIDout_2,*result,res, 1, joinRID_2,execMode);
				for(int i=0;i<planStatus->numTables;i++)
				{
					if(i!=tableID_1 &&i!=tableID_2)
					{
						int* tRIDout=planStatus->RID_baseTable[i];
						//int* joinRID=new int[res];
						int* joinRID=(int*)malloc(sizeof(int)*res);
						genOriginalRIDs(tRIDout,*result,res, 1, joinRID,execMode);
						planStatus->RID_baseTable[i]=joinRID;
						planStatus->RIDLen[i]=res;
						free(tRIDout);
					}                    					
				}
			}
			//update the status of the query plan.
			RIDout_2=planStatus->RID_baseTable[tableID_2];
			free(RIDout_2);
			planStatus->RID_baseTable[tableID_2]=joinRID_2;
			planStatus->RIDLen[tableID_2]=res;
			

		}
		break;
	case TYPE_PROJECTION:
		{
			__DEBUG2__("projection",table1);
			int col=0;			
			//check the length
			int i=0, k=0, rLen=0;
			if(planStatus->numTables>1)
			{
				rLen=planStatus->RIDLen[0];
				for(i=0;i<planStatus->numTables-1;i++)
				{
					if(planStatus->RIDLen[i]!=planStatus->RIDLen[i+1])
					{
						cout<<"table length is not match: TYPE_PROJECTION"<<endl;
						exit(0);
					}
				}
			}
			int ** projResult=(int **)malloc(sizeof(int*)*num_col);
			//for(col=0;col<num_col;col++)
			//	projResult[col]=new int[rLen];
			char tableName[NAME_MAX_LENGTH];
			char *curColumn;
			int res;
			for(col=0;col<num_col;col++)
			{
				//get the table.
				int strLen=(int)strlen(columns[col]);
				curColumn=columns[col];
				for(k=0; k<strLen; k++)
					if(curColumn[k]=='.')
					{
						strncpy(tableName,curColumn,k);
						tableName[k]='\0';
						break;
					}
				int tableID=planStatus->getBaseTable(tableName);
				if(tableID==-1)
				{
					Record **Rout=(Record**)malloc(sizeof(Record*));
					rLen=rSelectBaseTable(tableName, curColumn, Rout,execMode);
					//int* RIDout=new int[rLen];
					int* RIDout=(int*)malloc(sizeof(int)*rLen);
					getRIDs(*Rout,rLen,0, RIDout,execMode);
					tableID=planStatus->addBaseTable(tableName,RIDout,rLen);
				}
				else
					rLen=planStatus->RIDLen[tableID];
				//do the projection.
				res=simpleProjection(planStatus->RID_baseTable[tableID],rLen,tableName,&(columns[col]),1,&(projResult[col]),execMode);
				if(res==rLen) 
				{
#ifdef DEBUG
					for(int j=0;j<res;j++)
					{
						cout<<projResult[col][j]<<"\t";
						if(j>10) break;
					}
					cout<<"!!!!!"<<res<<endl;
#endif
				}
				else
				{
					cout<<"wrong in the projection: simpleProjection"<<endl;
				}

			}
			if(nodeLevel==0)
			{
				planStatus->finalResult=(int *)malloc(sizeof(int)*num_col*res);
				planStatus->numResultColumn=num_col;
				planStatus->numResultRow=res;
				int *result=planStatus->finalResult;
				int i;
				for(i=0;i<res;i++)
					for(int j=0;j<num_col;j++)
						result[i*num_col+j]=projResult[j][i];
				for(i=0;i<num_col;i++)
					free(projResult[i]);
				free(projResult);

			}

		}
		break;
	case TYPE_AGGREGATION:
		{
			__DEBUG2__("aggregation",table1);
			//the agg type is stored in table2
			int tableID=planStatus->getBaseTable(table1);
			int rLen=0;
			int* RIDout=NULL;
			if(tableID==-1)
			{
				Record **Rout=(Record**)malloc(sizeof(Record*));
				rLen=rSelectBaseTable(table1, columns[0], Rout,execMode);
				RIDout=(int*)malloc(sizeof(int)*rLen);
				getRIDs(*Rout,rLen,0, RIDout,execMode);
				tableID=planStatus->addBaseTable(table1,RIDout,rLen);
			}
			else
			{
				RIDout=planStatus->RID_baseTable[tableID];
				rLen=planStatus->RIDLen[tableID];
			}
			Record **result=(Record **)malloc(sizeof(Record*));
			int res=rAggregation(table1,columns[0],RIDout,rLen,table2, result,execMode);
#ifdef DEBUG
			if(res!=0) 
			{
				for(int j=0;j<res;j++)
				{
					cout<<(*result)[j].value<<"\t";
					cout<<endl;
					if(j>10) break;
				}
				cout<<"!!!!!"<<res<<endl;
			}
#endif
			if(nodeLevel==0)
			{
				planStatus->finalResult=(int*)malloc(sizeof(int)*res);
				int i=0;
				for(i=0;i<res;i++)
				{
					planStatus->finalResult[i]=(*result)[i].value;
				}
				free(*result);
				free(result);				
				planStatus->numResultColumn=1;
				planStatus->numResultRow=res;
			}

			
		}
		break;
	case TYPE_ORD:
		{
			__DEBUG2__("order by ",table1);
			int tableID=planStatus->getBaseTable(table1);
			int rLen=0;
			int *RIDout=NULL;
			if(tableID==-1)
			{
				Record **Rout=(Record**)malloc(sizeof(Record*));
				rLen=rSelectBaseTable(table1, columns[0], Rout,execMode);
				RIDout=(int*)malloc(sizeof(int)*rLen);
				getRIDs(*Rout,rLen,0, RIDout,execMode);
				tableID=planStatus->addBaseTable(table1,RIDout,rLen);
			}
			else
			{
				RIDout=planStatus->RID_baseTable[tableID];
				rLen=planStatus->RIDLen[tableID];
			}
			int *permutation=(int *)malloc(sizeof(int)*rLen);
			int res=rOrder(table1,columns[0],RIDout,rLen,permutation,execMode);
			int i=0;
			for(i=0;i<planStatus->numTables;i++)
			{
				//if(i!=tableID)
				rPermutation(planStatus->RID_baseTable[i],rLen,permutation,execMode);
			}
					
		}
		break;
	}
	clock_t l_endTime = clock();
	printf("time, %.3f ms, \n",(l_endTime-l_startTime)*1000/ (double)CLOCKS_PER_SEC);
}

QueryPlanNode::QueryPlanNode()
{
	opt = TYPE_UNKNOWN;
	table1 = NULL;
	table2 = NULL;
	columns = NULL;
	num_col = 0;
}

QueryPlanNode::~QueryPlanNode()
{
//	delete [] opt;
//	delete [] table1;
//	delete [] table2;

//	for (int i = 0; i < num_col; i++)
//		delete [] columns[i];
//	delete columns;
}
