#ifndef QUERYPLANNODE_H
#define QUERYPLANNODE_H

#include "db.h"
#include "ExecStatus.h"


#define PREDICATE_END -1
#define PREDICATE_UNKNOWN 0
#define PREDICATE_NUM 1
#define PREDICATE_COL 2
#define PREDICATE_AND 3
#define PREDICATE_OR 4
#define PREDICATE_EQUAL 5
#define PREDICATE_BIG 6
#define PREDICATE_SMALL 7
#define PREDICATE_NOTBIG 8
#define PREDICATE_NOTSMALL 9
#define PREDICATE_NOTEQUAL 10


struct PREDICATE_ARRAY_NODE
{
	int flag;
	int val;
	//int (*fp)(int a, int b);  
};

struct _PREDICATE_NODE
{
	_PREDICATE_NODE * left;
	_PREDICATE_NODE * right;
	char * opt;
};

struct PREDICATE_NODE
{
	_PREDICATE_NODE * root;
	char * GPU_str;
	char * CC_str;
	PREDICATE_ARRAY_NODE * array;
};



class QueryPlanNode
{
public:
//attributes,
	QueryPlanNode * left;
	QueryPlanNode * right;
//	PREDICATE_NODE * nodeArray;
	PREDICATE_NODE * predicateRoot;
	ExecStatus *planStatus;
	bool execMode;

	int opt;
	char * table1;
	char * table2;
	char ** columns;
	int num_col;
	int predicate_num;
	int type;
	int band_min;
	int band_max;

	QueryPlanNode();
	~QueryPlanNode();


	void initialNode(char * str, ExecStatus *status,  bool mode);
	void execute(int nodeLevel);

//methods,
	char * get_GPU_predicate_string(_PREDICATE_NODE * root);
	char * get_CC_predicate_string(_PREDICATE_NODE * root);

	int construct_GPU_predicate_string(_PREDICATE_NODE * root, char * str);
	int construct_CC_predicate_string(_PREDICATE_NODE * root, char * str);

	int construct_predicate_array(_PREDICATE_NODE * root, int index);
//	PREDICATE_NODE * construct_predicate_tree(char * str);
	_PREDICATE_NODE * construct_predicate_tree(char * str, int * index);
	void delete_predicate_tree(PREDICATE_NODE * node);
	int checkType();
	int getOperandType(char * str);
	int getCompare(_PREDICATE_NODE * node, char **, char **);
};

#endif

