#ifndef DB_H
#define DB_H
#include "stdlib.h"
#include "math.h"

struct Record{
int rid;
int value;
};

#define EVAL(Rhs, Tmp) { Rhs->value = Tmp->value;Rhs->rid = Tmp->rid;}
//#define SWAP(FROM, TO, TMP) { EVAL(TMP,FROM); EVAL(FROM,TO); EVAL(TO,TMP);}

int compareRecord (const void * a, const void * b);
int compareRID (const void * a, const void * b);

#define MAX_TABLE_NUM 32

#define TOTAL_BITS 32

#define NAME_MAX_LENGTH 256

#define DEFAULT_DB_SIZE (150*1024)

#define SUCCEED 0
#define TABLE_NOT_FOUND 1

#define MAX_PREDICATE_NODE 256

#define MAX_PREDICATE_STRING 1024

typedef int RET_VALUE;

//the operator type.
#define TYPE_SELECTION	0
#define TYPE_SEL_EQUAL	TYPE_SELECTION + 1
#define TYPE_SEL_BAND	TYPE_SELECTION + 2
#define TYPE_SEL_OTHER	TYPE_SELECTION + 3
#define TYPE_JOIN	10
#define TYPE_JOIN_EQUAL TYPE_JOIN + 1
#define TYPE_JOIN_BAND	TYPE_JOIN + 2
#define TYPE_JOIN_OTHER TYPE_JOIN + 3
#define TYPE_PROJECTION	20
#define TYPE_AGGREGATION 30 
#define TYPE_ORD 40
#define TYPE_UNKNOWN	-1


#define NUM_ENTRY 32
struct Bucket{
	Record data[NUM_ENTRY];
	Bucket *next;
	void init()
	{
		next=NULL;
	}
};


//for VEB layout
#define DIRECT_LEVEL 3


#define CC_EXEC false
#define CO_EXEC true

#define MAX_TABLE_PER_QUERY 32

#define TRUE true
#define FALSE false



#endif

