//#define NON_LINUX_PLAT
#include <stdlib.h>
#include <string.h>
#include "evaluateFuction.h"
#ifndef NON_LINUX_PLAT
#include <dlfcn.h>
#endif
//int *stack=new int[256];

int evaluate(int * row, PREDICATE_NODE * pRoot,  int *stack, int node_num)
{	
	
	int i, p = 0;
	int result;
	PREDICATE_ARRAY_NODE* node=pRoot->array;

	for (i = 0; i < node_num; i++)
	{
		switch (node[i].flag)
		{
		case PREDICATE_END:
			result = stack[0];
			//delete [] stack;
			return result;

		case PREDICATE_NUM:
			stack[p++] = node[i].val;
			break;
		case PREDICATE_COL:
			stack[p++] = row[node[i].val];
			break;
		case PREDICATE_AND:
			stack[p - 2] = (stack[p - 2] && stack[p - 1]);
			p--;
			break;
		case PREDICATE_OR:
			stack[p - 2] = (stack[p - 2] || stack[p - 1]);
			p--;
			break;
		case PREDICATE_EQUAL:
			stack[p - 2] = (stack[p - 2] == stack[p - 1]);
			p--;
			break;
		case PREDICATE_BIG:
			stack[p - 2] = (stack[p - 2] > stack[p - 1]);
			p--;
			break;
		case PREDICATE_SMALL:
			stack[p - 2] = (stack[p - 2] < stack[p - 1]);
			p--;
			break;
		case PREDICATE_NOTBIG:
			stack[p - 2] = (stack[p - 2] <= stack[p - 1]);
			p--;
			break;
		case PREDICATE_NOTSMALL:
			stack[p - 2] = (stack[p - 2] >= stack[p - 1]);
			p--;
			break;
		case PREDICATE_NOTEQUAL:
			stack[p - 2] = (stack[p - 2] != stack[p - 1]);
			p--;
		}
	}

	result = stack[0];
	//delete [] stack;
	return result;
	
}

#ifndef NON_LINUX_PLAT
int initialPredicate(char * predicate)
{

	char* headerFile="LibSOPredicate.h";
	FILE *dbFile = fopen(headerFile, "w");
	if(dbFile!=NULL)
	{						
		char* str="#define EVALUATE(row) ";
		int len=(int)strlen(str);
		char toWrite[1024];
		memset(toWrite, '\0', 1024);
		strcpy(toWrite, str);
		int towriteLen=strlen(predicate);
		strncpy(toWrite+len, predicate, towriteLen);
		fprintf(dbFile, "%s",toWrite);
		fclose(dbFile);
		system("chmod +x libPredicate.sh");	
		system("./libPredicate.sh");			
	}
	else
	{
		printf("the header file: %s not found\n", headerFile);
	}
	return 0;
}

IN_INT_OUT_INT openDLL(void** pdlhandle)
{
	
	char* pszerror;
	
	IN_INT_OUT_INT EVAL;
	//void (*GetInt)(char* psztxt);
	
	// open mytestso.so
	*pdlhandle = dlopen("./libPredicate.so", RTLD_LAZY);
	pszerror = dlerror();
	if (0 != pszerror) {
		printf("1: %s\n", pszerror);
		exit(1);
	}
	
	// get GetMax func
	EVAL = (IN_INT_OUT_INT)(dlsym(*pdlhandle, "PEvaluate"));
//	GetMax =(int*) dlsym(pdlhandle, "GetMax")(int, int);
	pszerror = dlerror();
	if (0 != pszerror) {
		printf("3: %s\n", pszerror);
		exit(1);
	}
	return EVAL;
}

void closeDLL(void** pdlhandle)
{
	dlclose(*pdlhandle);
}
#else//non-linux
int initialPredicate(char * predicate)
{

	return 0;
}

IN_INT_OUT_INT openDLL(void** pdlhandle)
{
	return NULL;
}

void closeDLL(void** pdlhandle)
{
	
}
#endif