#ifndef QP_UTILITY_H
#define QP_UTILITY_H
#include "db.h"
#include <iostream>
using namespace std;

#define divRoundDown(n,s)  ((n) / (s))
#define divRoundUp(n,s)    (((n) / (s)) + ((((n) % (s)) > 0) ? 1 : 0))

int Log2(int num);
int LogLog2(int num);

//#define min(a,b)  (((a) < (b)) ? (a) : (b))
//#define max(a,b)  (((a) > (b)) ? (a) : (b))

#define OFFSET ((1<<15)-1)
#define TEST_MAX ((1<<30)-1)
#define NON_LINUX_PLAT 1
#ifdef NON_LINUX_PLAT
#define RAND(MAX) ((((rand()& OFFSET)<<15)+(rand()&1))+(rand()<<1)+(rand()&1))%MAX
#else
#define RAND(MAX) (rand())%MAX
#endif


void checkSorted(Record *R, int rLen);

#define SWAP(Lhs, Rhs, Tmp) { \
			 Tmp = *Lhs;\
            *Lhs = *Rhs;\
            *Rhs = Tmp;\
        }
/*#define SWAP(Lhs, Rhs, Tmp) { \
			 Tmp->value = Lhs->value;Tmp->rid = Lhs->rid;\
             Lhs->value = Rhs->value;Lhs->rid = Rhs->rid;\
            Rhs->value = Tmp->value;Rhs->rid = Tmp->rid;\
        }*/

#define DEBUG 1
#ifdef DEBUG
#define __DEBUG__(str) {printf("%s\n", str);}
#define __DEBUG2__(M1,M2) {printf("%s,%s\n", M1,M2);}
#define __DEBUG3__(M1,M2,M3) {printf("%s,%s,%s\n", M1,M2,M3);}
#define __DEBUGInt__(intValue) {printf("%d\n", intValue);}
#define __DEBUGInt2__(intValue1, intValue2) {printf("%d, %d\n", intValue1,intValue2);}
#else
#define __DEBUG__(str) {;}
#define __DEBUG2__(M1,M2) {;}
#define __DEBUGInt__(intValue) {;}
#define __DEBUG3__(M1,M2,M3) {;}
#define __DEBUGInt2__(intValue1, intValue2) {;}
#endif

//the string functions are not supported in Linux. so we rewrite it.
/*
reverse the string.
*/
char* linux_strrev(char* szT);
/*
transform <value> into a string with radix <radix>
*/
void linux_itoa(int value, char*  str, int radix);


void DirectComputeVEB(int level, int * VEB_SIZE);
void ComputeVEB(int rLen, int level, int * VEB_SIZE);
void NewVEB(int fromLevel, int toLevel, int totalLevel, int *VEBSIZE);

/*
determine whether x is 2^n
*/
bool is2n(unsigned int x);

//for the evaluation function in the dll.
typedef int (*IN_INT_OUT_INT)(int*);

#endif

